/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */




/**
 *
 * @author me
 */
import java.awt.*;
import java.applet.*;
import java.awt.Color.*;
import java.awt.event.*;
//import java.awt.event.MouseWheelListener;
import java.lang.Math.*;



/////

class mouse_class {
 int x=10,y=25; // current position of mouse
 boolean is_dragged;
 boolean is_double_click;
 boolean pressed_right;
 boolean pressed_left;
 public void get_pos(int xx, int yy){ x = xx;y = yy; };
 public void get_is_dragged(boolean b){ is_dragged=b; };
 public void get_is_double_click(boolean b){ is_double_click=b; };
}

class integrate_class {
double time_step;
public void set_time_step(double dt){ time_step = dt;};
}

 class flags_class{
  String starting_configuration = "inner_solar";
  boolean close_contact=false;
  boolean history_overflow=false;
  boolean start_from_zero_momentum=true;
  Boolean[] plot_what = new Boolean[11]; /* o Apply this to all of them
    pt=(0=Current_sphere_no_history,
        1=points_history,
        2=connect_points_history,
        3=Velocities_Normal_no_history,
        4=Velocities_Tangential_no_history,
        5=Velocities_Normal_with_history,
        6=Velocities_Tangential_with_history,
        7=Accelerations_Normal_no_history,
        8=Accelerations_Tangential_no_history,
        9=Accelerations_Normal_with_history,
        10=Accelerations_Tangential_with_history, )
  */
 }

 class physical_constants{ // given in SI
   final static double Gravity =  6.67428e-11;
   final static double Plank = 6.626068e-34 ;
   final static double Earth_mass = 5.9742e24;
   final static double Earth_to_Sun_distance = 149597871e3;
   final static double one_hour = 3600.0;
 }

  class unit {
  final static double mass = physical_constants.Earth_mass; // Earth mass
  final static double length = physical_constants.Earth_to_Sun_distance;
  final static double time = physical_constants.one_hour;
  final static double force = mass * length / time/time;
  final static double energy = force * length;
  final static double speed = length/time;
  final static double linmom = mass *  speed;
  }
   class plot_planet_style_class{
   Color line_color = new Color(0,0,0);
   Color sphere_color = new Color(255,0,0);
   int sphere_radius = 15;
   Boolean[] plot_what = new Boolean[11];

 };
class planet_class {
  double radius;
  double density;
  double mass;
  boolean close_contact = false; // true if 2 palnets are in close contact
  double[] xyz = new double[3];
  double[] vxyz = new double[3];
  double[] fxyz = new double[3];
  double[] axyz = new double[3];
  double[] pxyz = new double[3];
  String name = new String();
  plot_planet_style_class plot_planet_style = new plot_planet_style_class();
}

class energy_class{
 double pot;
 double kin;
 double tot;
}
class history_class {
 float[] xyz = new float[3];
 float[] vxyz = new float[3];
 float[] axyz = new float[3];
 float[] vv2 = new float[3]; // perpendicular and parralel components
 float[] aa2 = new float[3];
 int[]   pixels = new int[2];//xy in pixels
}

class orient_class {
 int azimuth = 20;
 int elevation = 10;
}

class perspective_class {
 float near;
 float near_to;
}

class MainImage_class { //
orient_class orient = new orient_class();
perspective_class perspective = new perspective_class();
int height;
int width;
int picture_height;
int picture_width;
float scale_factor; // who % of screen will be occupied by plot
final float  Default_scale_factor=100;
int x0,y0;
int X0,Y0;
Color background;
public void defaults() {
  height = 500;
  width = 500;
  scale_factor = Default_scale_factor;
  orient.azimuth = 45;
  orient.elevation = 30;
  perspective.near = 10;
  perspective.near_to = 10;
  background = Color.black;
  picture_width=width;
  picture_height=height;
  Y0=height/2;
  X0=width/2;
  x0=X0;y0=Y0;
}
}

class mass_centra_class{
 double[] xyz = new double[3];
 double[] vxyz = new double[3];
 double[] axyz = new double[3];
 public void get_rva(planet_class[] P){
 int i,j,k;
 double sm=0.0;
 for (k=0;k<3;k++){ xyz[k] = 0.0;};
 for (i=0;i<P.length;i++){
 sm+=P[i].mass;
 for (k=0;k<3;k++){
     xyz[k] += P[i].xyz[k] *P[i].mass;
    vxyz[k] += P[i].vxyz[k]*P[i].mass;
    axyz[k] += P[i].axyz[k]*P[i].mass;
 }
 }

 for (k=0;k<3;k++){
      xyz[k] = xyz[k]/sm;
     vxyz[k] = vxyz[k]/sm;
     axyz[k] = axyz[k]/sm;
 }

 }
}
///  END CLASSES


class drawing_class{
   public void paintArrow(Graphics g, int x0, int y0, int x1,int y1){
	int dX = x1 - x0;
	int dY = y1 - y0;
	double f = 0.2;

	g.drawLine(x0,y0,x1,y1);
	g.drawLine(x0 + (int)((1-f)*dX + f*dY),
		   y0 + (int)((1-f)*dY - f*dX),
		   x1, y1);
	g.drawLine(x0 + (int)((1-f)*dX - f*dY),
		   y0 + (int)((1-f)*dY + f*dX),
		   x1, y1);

   }

}


class physics_class {
public boolean forces(planet_class[] planets, energy_class energy){ // evaluate forces and potential energies.
  int i,j,k,N;
  double[] t = new double[3];double[] dr = new double[3]; double[] fi = new double[3];
  double mass_i,r_ij,r_sq_ij,i_r_ij,ff,Uij;
  N=planets.length;
  energy.pot = 0.0;
  for (i=0;i<N;i++){ for (j=0;j<3;j++){planets[i].fxyz[j]=0.0;}};
  for (i=0;i<N;i++){
  mass_i = planets[i].mass;  for (k=0;k<3;k++){ t[k] = planets[i].xyz[k]; fi[k]=0.0; };
   for (j=i+1;j<N;j++){
      for (k=0;k<3;k++){ dr[k] = t[k]-planets[j].xyz[k];};
      r_sq_ij  = dr[0]*dr[0]+dr[1]*dr[1]+dr[2]*dr[2];
      r_ij = Math.sqrt(r_sq_ij) ; i_r_ij = 1.0/r_ij;
      if (r_ij < planets[i].radius+planets[j].radius) {
		 return false;
      }
      Uij = - (physical_constants.Gravity * planets[j].mass * i_r_ij)  * mass_i;
      energy.pot +=  Uij;
      ff = Uij * i_r_ij * i_r_ij;
      for (k=0;k<3;k++){
          fi[k] += dr[k]*ff;
          planets[j].fxyz[k]  +=  - ff*dr[k];
      };
   } //j

   for (k=0;k<3;k++){ planets[i].fxyz[k]  += fi[k]; };
  }
  for (i=0;i<N;i++){ for (j=0;j<3;j++){
      planets[i].axyz[j] = planets[i].fxyz[j] / planets[i].mass;}
  };
 return true;
 }  ; // done with forces
public  void integrate_VV(planet_class[] planets, energy_class energy, double time_step){ //Integrate the equation of motions with a order 2 time reversible method (VV)
   int N = planets.length;
   energy.kin=0.0;
   for (int i=0;i<N;i++){
   energy.kin += 0.5*planets[i].mass*(planets[i].vxyz[0]*planets[i].vxyz[0]+planets[i].vxyz[1]*planets[i].vxyz[1]+planets[i].vxyz[2]*planets[i].vxyz[2]);
   for (int j=0;j<3;j++){
    planets[i].xyz[j] +=  planets[i].vxyz[j]*time_step+0.5*time_step*time_step*planets[i].axyz[j];
            //!r(t+1)=r(t)+v(t)*dt+dt^2/2*a(t)
   }
   }

  energy.tot = energy.kin+energy.pot;
  for (int i=0;i<N;i++){
   for (int j=0;j<3;j++){
    planets[i].vxyz[j] +=  planets[i].axyz[j]*(time_step*0.5);  //v(t+1/2) = v(t) + a(t)*dt/2
   }
   }

  boolean close_contact = forces(planets, energy);

  for (int i=0;i<N;i++){
   for (int j=0;j<3;j++){
    planets[i].vxyz[j] +=  planets[i].axyz[j]*(time_step*0.5);  //v(t+1)=v(t+1/2)+a(t+1)*dt/2
    planets[i].pxyz[j] = planets[i].vxyz[j] *  planets[i].mass;
   }
  // System.out.println(i+" "+planets[i].xyz[0]+" "+planets[i].xyz[1]+" " + planets[i].xyz[2]);
   }

//System.out.println(planets[1].xyz[0]+" "+planets[1].xyz[1]+" " + planets[1].xyz[2]);
}
}

// end physics


// SET UP
class planet_operation_class{
int relative_to=0;
int N_objects; // how many planets
 public void init_planets(planet_class[] planets, flags_class flags){
      System.out.println("N_objects="+N_objects);
      for(int i =0;i<N_objects;i++){
        planets[i] = new planet_class();
        for(int j=0;j<3;j++){
        planets[i].axyz[j]=0.0;
        planets[i].vxyz[j]=0.0;
        planets[i].fxyz[j]=0.0;
        planets[i].xyz[j]=0.0;
        planets[i].pxyz[j]=0.0;
        }


       for(int j=0;j<flags.plot_what.length;j++){
          planets[i].plot_planet_style.plot_what[j]=flags.plot_what[j];
        }
    };
  }
 public void set_planet_units_from_input_to_internal(planet_class[] planets){
  for (int i=0;i<planets.length;i++){ for(int k=0;k<3;k++){
      planets[i].vxyz[k]=planets[i].vxyz[k]*1000.0/3600.0 ; //from km/h to SI
      planets[i].xyz[k]=planets[i].xyz[k]*unit.length ;     // from Earth mass to SI

  }
  planets[i].radius=planets[i].radius*unit.length;
  planets[i].mass=planets[i].mass*unit.mass;
  };
  }
 public void validate_initial_momentum(planet_class[] planets){
    int i, imax,k,N;
    double nmax ;
    double[] t = new double[3];
    N=planets.length;
    nmax=planets[0].mass ;imax=0;
    for (i=0;i<N;i++){
     if (planets[i].mass >nmax){
      nmax=planets[i].mass;
      imax=i;
     }
    }
     for(k=0;k<3;k++){ t[k]=0.0;};
   for (i=0;i<N;i++){
    if (i!=imax) {
     for(k=0;k<3;k++){ t[k] += planets[i].mass * planets[i].vxyz[k];
     };
    }
   }
   for(k=0;k<3;k++){
       planets[imax].vxyz[k] = - t[k]/ nmax;
   };
}
 public void dr_planets(mass_centra_class mass_centra, planet_class[] planets, int which_planet, int relative, float[] dr, float[] dv, float[] da){
    int k,j=which_planet;
          if (relative > 0-1 ) {
        for (k=0;k<3;k++){
            dr[k] = (float) (planets[j].xyz[k] - planets[relative].xyz[k]) ;
            dv[k] = (float) (planets[j].vxyz[k] - planets[relative].vxyz[k]);
            da[k] = (float) (planets[j].axyz[k] - planets[relative].axyz[k]);
        };
        }else if (relative == 0-1) {
        for (k=0;k<3;k++){
            dr[k] = (float) (planets[j].xyz[k]);
            dv[k] = (float) (planets[j].vxyz[k]);
            da[k] = (float) (planets[j].axyz[k]);};
        }else { //relative to mass centra of the entire system
          mass_centra.get_rva(planets);
          for (k=0;k<3;k++){
              dr[k] = (float) (planets[j].xyz[k]-mass_centra.xyz[k]);
              dv[k] = (float) (planets[j].vxyz[k]-mass_centra.vxyz[k]);
              da[k] = (float) (planets[j].axyz[k]-mass_centra.axyz[k]);
          };
        }
}

}

class history_operation_class{
int increment_history=-1;
final static int MX_HISTORY = 10000;
int N_history = 800;
public void update_single_point_history( int i , planet_class[] planets,
        planet_operation_class planet_operation, mass_centra_class mass_centra,
        history_class[][] history, MainImage_class MainImage){

 int j,k;
 float[] dx= new float[3]; float[] dv= new float[3]; float[] da= new float[3];
 float rr,vv,aa,cos_angle;
   for (j=0;j<planets.length;j++){
       for (k=0;k<3;k++){
        history[i][j].xyz[k]=(float) (planets[j].xyz[k] /unit.length) ;
        history[i][j].vxyz[k]=(float) (planets[j].vxyz[k] *(3.6));
        history[i][j].axyz[k]=(float) (planets[j].axyz[k] *(3.6*3600));
      } //for k
       planet_operation.dr_planets(mass_centra, planets, j, planet_operation.relative_to, dx, dv, da);
       rr = (float) Math.sqrt(dx[0]*dx[0]+dx[1]*dx[1]+dx[2]*dx[2]);
       vv = (float) Math.sqrt(dv[0]*dv[0]+dv[1]*dv[1]+dv[2]*dv[2]);
       aa = (float) Math.sqrt(da[0]*da[0]+da[1]*da[1]+da[2]*da[2]);
       if (rr !=0 && vv !=0 ) {
       cos_angle = (dx[0]*dv[0]+dx[1]*dv[1]+dx[2]*dv[2])/ rr/vv; // parralel component
       }else{ cos_angle = (float) 0.0; };
       history[i][j].vv2[0] = (float)vv * cos_angle;
       history[i][j].vv2[1] = (float) ((float) vv * Math.sqrt(1.0 - cos_angle * cos_angle));

       if (rr !=0 && aa !=0 ) {
       cos_angle = (dx[0]*da[0]+dx[1]*da[1]+dx[2]*da[2])/ rr/vv; // parralel component
       }else{ cos_angle = (float) 0.0; };
       history[i][j].aa2[0] = (float)aa * cos_angle;
       history[i][j].aa2[1] = (float) ((float) aa *  Math.sqrt(1.0 - cos_angle * cos_angle));
       }
    update_the_pixels_history(planets,history,MainImage);
   }

public void update_the_pixels_history(planet_class[] planets, history_class[][] history,
        MainImage_class which_image){
 int i,j,k;
 float cosT=0, sinT=0, cosP=0, sinP=0, cosTcosP=0,cosTsinP=0, sinTcosP=0, sinTsinP=0;
 float x0=0,y0=0,z0=0,x1=0,y1=0;
         double theta = Math.PI*which_image.orient.azimuth/180.0;
         double phi = Math.PI*which_image.orient.elevation/180.0;
         cosT = (float)Math.cos(theta); sinT = (float)Math.sin(theta);
         cosP = (float)Math.cos(phi); sinP = (float)Math.sin(phi);
         cosTcosP = cosT*cosP; cosTsinP = cosT*sinP;
         sinTcosP = sinT*cosP; sinTsinP = sinT*sinP;
 for(i=0;i<increment_history+1; i++)  {
   for (j=0;j<planets.length; j++){
     // compute an orthographic projection
         x0 = (float)history[i][j].xyz[0];y0 = (float)history[i][j].xyz[1]; z0 = (float)history[i][j].xyz[2];
         x1 = cosT*x0 + sinT*z0;
         y1 = -sinTsinP*x0 + cosP*y0 + cosTsinP*z0;
         //  adjust things to get a perspective projection
         float z1 = cosTcosP*z0 - sinTcosP*x0 - sinP*y0;
         //System.out.println(j+"x0="+x0+" "+y0+" "+z0);
         //System.out.println(j+"x1="+x1+" "+y1);
         x1 = x1*which_image.perspective.near/(z1+which_image.perspective.near+which_image.perspective.near_to);
         y1 = y1*which_image.perspective.near/(z1+which_image.perspective.near+which_image.perspective.near_to);

         // the 0.5 is to round off when converting to int
         history[i][j].pixels[0] = (int)(which_image.x0 + which_image.scale_factor*x1 + 0.5);
         history[i][j].pixels[1] = (int)(which_image.y0 - which_image.scale_factor*y1 + 0.5);
         //System.out.println( history[i][j].pixels[0]+ " "+ history[i][j].pixels[1]);
   }
 }
}

public void update_all_history( planet_class[] planets,
        planet_operation_class planet_operation, mass_centra_class mass_centra,
        history_class[][] history, MainImage_class MainImage, flags_class flags) {
   int i,j,k;
   increment_history = increment_history + 1;
   flags.history_overflow = increment_history > N_history-1;
   if (flags.history_overflow){
      increment_history=N_history-1;
      for (i=1;i<N_history;i++){ //snake-like move of data
        for (j=0;j<planets.length;j++){
        for (k=0;k<3;k++){
          history[i-1][j].xyz[k]=history[i][j].xyz[k];
          history[i-1][j].vxyz[k]=history[i][j].vxyz[k];
          history[i-1][j].axyz[k]=history[i][j].axyz[k];
        } //k
      //  System.out.println(history[i][1].xyz[0]+" "+history[i][1].xyz[1]+" "+history[i][1].xyz[2]+" "+increment_history);
        for (k=0;k<2;k++){
          history[i-1][j].aa2[k]=history[i][j].aa2[k];
          history[i-1][j].vv2[k]=history[i][j].vv2[k];
          history[i-1][j].pixels[k]=history[i][j].pixels[k];
        } //k
        } //for (j=0;j<N_objects;j++)
      } // or (i=1;i<history.length;i++)
      update_single_point_history(increment_history, planets,
        planet_operation, mass_centra,history, MainImage) ; //update the last point
   }else{
      update_single_point_history(increment_history, planets,
        planet_operation, mass_centra,history, MainImage); //update the last point
   }
 //System.out.println(history[1][1].xyz[0]+" "+history[1][1].xyz[1]+" "+history[1][1].xyz[2]+" "+increment_history);
 }

public void reset_history(){ increment_history=-1;};

}


//
public class test1 extends Applet implements Runnable  {

  Object ThreadLock = new Object();
  Graphics MainGraphics;
  Image MainImageBuffer;
  int Nprint;
  Thread thread=null;


public void start(){
thread = new Thread(this);
thread.start();
}

public void init(){
    drawing = new drawing_class();
    MainImage = new MainImage_class();
    MainImage.defaults();
    defaults();
    initialize();
    addMouseListener( new MouseAdapter(){

       public  void mouseClicked(MouseEvent e) {       }
       public void mouseDoubleClicked (MouseEvent e){System.exit(0);};
       public void mouseRelead( MouseEvent e){
        mouse.pressed_right=false;
        mouse.pressed_left=false;
       }
       public void mousePressed( MouseEvent e ) {
          mouse.get_pos(e.getX(),e.getY());
           if (e.getButton() == MouseEvent.NOBUTTON)
                {
                    mouse.pressed_right=false;
                    mouse.pressed_left=false;
               } else if (e.getButton() == MouseEvent.BUTTON1) {
                    mouse.pressed_right=false;
                    mouse.pressed_left=true;
                } else if (e.getButton() == MouseEvent.BUTTON2) {
                     mouse.pressed_right=false;
                    mouse.pressed_left=false;
                } else if (e.getButton() == MouseEvent.BUTTON3) {
                    mouse.pressed_right=true;
                    mouse.pressed_left=false;
                }
          e.consume();
       }
    });
    addMouseMotionListener( new MouseAdapter(){
     public void mouseDragged( MouseEvent e ) {
      if(mouse.pressed_left){
      // get the latest mouse position
      int new_mx = e.getX();
      int new_my = e.getY();
      // adjust angles according to the distance travelled by the mouse
      // since the last event
      MainImage.orient.azimuth -= new_mx - mouse.x;
      MainImage.orient.elevation += new_my - mouse.y;
      mouse.get_pos(new_mx,new_my);
      hist.update_the_pixels_history(planets,history,MainImage);
      MainGraphics.setColor( MainImage.background );
      MainGraphics.fillRect( 0, 0, MainImage.height, MainImage.width );
      paint_whole_history(MainGraphics);
      // update our data
      repaint();
      e.consume();
     }else if (mouse.pressed_right){
       int new_mx = e.getX();
       int new_my = e.getY();
       MainImage.x0 += new_mx - mouse.x;
       MainImage.y0 += new_my - mouse.y;
       mouse.get_pos(new_mx,new_my);
       hist.update_the_pixels_history(planets,history,MainImage);
       MainGraphics.setColor( MainImage.background );
       MainGraphics.fillRect( 0, 0, MainImage.height, MainImage.width );
       paint_whole_history(MainGraphics);
       repaint();
       e.consume();
     }
   }

    } );
    addMouseWheelListener(new MouseWheelListener(){
      public void mouseWheelMoved(MouseWheelEvent e) {
         if (e.getWheelRotation() < 0){
             zoom(0.9f,MainImage);
         MainGraphics.setColor( MainImage.background );
         MainGraphics.fillRect( 0, 0, MainImage.height, MainImage.width );
         hist.update_the_pixels_history(planets, history,MainImage);
         paint_whole_history( MainGraphics );
         repaint();
         }else {
             zoom(1.1f,MainImage);
         MainGraphics.setColor( MainImage.background );
         MainGraphics.fillRect( 0, 0, MainImage.height, MainImage.width );
         hist.update_the_pixels_history(planets, history,MainImage);
         paint_whole_history( MainGraphics );
         repaint();
         }
//throw new AssertionError("Mouse Wheel moved");
            }


       } );

    synchronized (ThreadLock ){
    MainImageBuffer = createImage(MainImage.height, MainImage.width);
    MainGraphics = MainImageBuffer.getGraphics();
    }
    MainGraphics.setColor( MainImage.background );
    MainGraphics.fillRect( 0, 0, MainImage.height, MainImage.width );
    compute_history();
    paint_whole_history( MainGraphics );
    repaint();
};

public void run(){
  while (thread == Thread.currentThread()){
    compute_history();
    render(MainGraphics,MainImageBuffer);
    try{Thread.sleep(40);}catch(InterruptedException io){};
  }

}
public void stop(){thread=null;}

protected void zoom(float factor, MainImage_class which_image){
 //float nh = which_image.picture_height*factor;//this is for move
 //float nw = which_image.picture_width*factor;
 //which_image.picture_height = (int) nh;
 //which_image.picture_width = (int) nw;

    float hn = which_image.scale_factor*factor;
    which_image.scale_factor =  hn;
    if(which_image.scale_factor==0)which_image.scale_factor=1.0f;

}

private void compute_history(){
for (int j=0;j<1;j++){
   for (int i=0;i<Nprint;i++){physics.integrate_VV(planets, energy, integrate.time_step);};
   hist.update_all_history(planets,planet_operation, mass_centra,history,MainImage,flags);
 }
}

protected void render(Graphics g, Image image){
    synchronized (ThreadLock){
      g.drawString("Hello World!", 10, 30);
      g.setColor( MainImage.background );
      g.fillRect( 0, 0, MainImage.height, MainImage.width );
      paint_whole_history(g);
    }
  repaint();
}

public void update(Graphics g){paint(g);}

public void paint(Graphics g) {
synchronized(ThreadLock){
g.drawImage( MainImageBuffer, 0, 0, null );
 //System.exit(0);
}
}



 private void initialize(){

   planet_operation.N_objects = 6;
   if (flags.starting_configuration.equals("inner_solar")) {
    //N_objects = planet_operation.N_objects; // start from Sun/Mercury/.../Jupiter
    planets = new planet_class[planet_operation.N_objects];
    planet_operation.init_planets(planets,  flags);
    planets[0].mass = 330.0e3;planets[0].name = "Sun";
    planets[0].density = 1400.0 ; //kg/m^3
    planets[0].plot_planet_style.line_color=Color.red;
    planets[0].plot_planet_style.sphere_color=Color.red;
    planets[0].plot_planet_style.sphere_radius=12;

    planets[1].mass = 0.0553;planets[1].name = "Mercury";
    planets[1].xyz[0]=0.39 ;
    planets[1].vxyz[1]=-172.332e3 ;
    planets[1].density = 5500.0 ; //kg/m^3
    planets[1].plot_planet_style.line_color=Color.yellow;
    planets[1].plot_planet_style.sphere_color=Color.yellow;
    planets[1].plot_planet_style.sphere_radius=2;

    planets[2].mass = 0.815;planets[2].name = "Venus";
    planets[2].xyz[0]=0.72 ;
  //  planets[2].vxyz[1]=-126.936e3 ;
    planets[2].vxyz[0]=-76.936e3 ;planets[2].vxyz[1]=-76.936e3 ;
    planets[2].density =5204.0;
    planets[2].plot_planet_style.line_color=Color.green;
    planets[2].plot_planet_style.sphere_color=Color.green;
    planets[2].plot_planet_style.sphere_radius=4;

    planets[3].mass = 1.0;planets[3].name = "Earth";
    planets[3].xyz[0]=1.0 ;
  //  planets[3].vxyz[1]=-107.300e3 ;
    planets[3].vxyz[1]=-70.300e3 ;planets[3].vxyz[2]=-107.300e3 ;
    planets[3].density =4400.0; //kg/m^3
    planets[3].plot_planet_style.line_color=Color.white;
    planets[3].plot_planet_style.sphere_color=Color.white;
    planets[3].plot_planet_style.sphere_radius=5;

    planets[4].mass = 0.107;planets[4].name = "Mars";
    planets[4].xyz[0]=1.520 ;
  //  planets[4].vxyz[1]=-86.868e3 ;
    planets[4].vxyz[0]=-36.868e3 ;planets[4].vxyz[1]=-36.868e3 ;planets[4].vxyz[2]=-36.868e3 ;
    planets[4].density =3940.0;
    planets[4].plot_planet_style.line_color=Color.cyan;
    planets[4].plot_planet_style.sphere_color=Color.cyan;
    planets[4].plot_planet_style.sphere_radius=3;

    planets[5].mass = 317.83;planets[5].name = "Jupiter";
    planets[5].xyz[0]=5.20 ;
 //   planets[5].vxyz[1]=-29.392e3 ;
   planets[5].vxyz[1]=-9.392e3 ;  planets[5].vxyz[2]=-9.392e3 ;
    planets[5].density= 1330 ; //
    planets[5].plot_planet_style.line_color=Color.red;
    planets[5].plot_planet_style.sphere_color=Color.red;
    planets[5].plot_planet_style.sphere_radius=8;


   }else if (flags.starting_configuration.equals("outer_solar")){
    planet_operation.N_objects = 5; // Jupiter Saturn Uranus Neptun Pluto
    planet_operation.init_planets(planets,  flags);
   }else if (flags.starting_configuration.equals("binary")) {
    planet_operation.N_objects = 2; // Jupiter Saturn Uranus Neptun Pluto
    planet_operation.init_planets(planets,  flags);
   }else if (flags.starting_configuration.equals("ternary")){
    planet_operation.N_objects = 3; // Jupiter Saturn Uranus Neptun Pluto
    planet_operation.init_planets(planets,  flags);
   }else if (flags.starting_configuration.equals("custom")){
    // CUSTOM
   }else {
    System.out.println("ERROR : CASE UNDEFINED IN init() flags.starting_configuration is not in range");
    System.exit(0);
   }

      //finish initializations

   history = new history_class[hist.MX_HISTORY][planet_operation.N_objects]; // the actual size of history MOVE IT
   hist.N_history = Math.min(hist.N_history,hist.MX_HISTORY);
   for (int i=0;i<hist.N_history;i++){ for(int j=0;j<planet_operation.N_objects;j++){
       history[i][j] = new history_class();}};
   hist.increment_history = Math.min(hist.increment_history, hist.N_history-1);
   planet_operation.set_planet_units_from_input_to_internal(planets);

   for (int i = 0; i<planet_operation.N_objects; i++){
     planets[i].radius=3.0/(4.0*3.14)*Math.pow(planets[i].mass/planets[5].density, 1.0/3.0);

   };
   double maxrad = -1.0;
   for (int i = 0; i<planet_operation.N_objects; i++){ if (planets[i].radius>maxrad) {maxrad=planets[i].radius;}};
  // for (int i = 0; i<N_objects; i++){planets[i].plot_planet_style.sphere_radius = (int) (planets[i].radius/maxrad * 10.0);};

   System.out.println(flags.start_from_zero_momentum);
   if (flags.start_from_zero_momentum) {planet_operation.validate_initial_momentum(planets);};





  }






  double[] linmom = new double[3];




history_class[][] history;
planet_class[]  planets;
mass_centra_class mass_centra;
energy_class energy;
physics_class physics;
flags_class flags;
planet_operation_class planet_operation;
MainImage_class MainImage;// this may be wrong
drawing_class drawing;
history_operation_class hist;
integrate_class integrate;
mouse_class mouse;






private void defaults(){

    mass_centra = new mass_centra_class();
    energy = new energy_class();
    physics =new physics_class();
    flags = new flags_class();
    planet_operation = new planet_operation_class();
    hist = new history_operation_class();
    integrate = new integrate_class(); integrate.set_time_step(0.1 * unit.time);
    mouse = new mouse_class();

    for(int i=0;i<flags.plot_what.length;i++){flags.plot_what[i]=false;} ;
    flags.plot_what[0]=true;
    flags.plot_what[1]=true;
    flags.plot_what[2]=true;
    Nprint = 1000;
    energy.kin=0.0; energy.pot=0.0; energy.tot=0.0;
    for (int i=0;i<linmom.length;i++){linmom[i]=0.0;};
  }


//deal with plots0
private void paint_whole_history(Graphics g) {
int i,j,k;
int x0,y0,x1,y1;
if (hist.increment_history>3){
      for (j=0;j<planets.length;j++){
        g.setColor( planets[j].plot_planet_style.line_color );
        for (i=1;i<hist.increment_history;i++){
        if (planets[j].plot_planet_style.plot_what[2]){
            g.drawLine(
            history[i  ][j].pixels[0], history[i  ][j].pixels[1],
            history[i-1][j].pixels[0], history[i-1][j].pixels[1]
         );
        }
        }
}
 for (j=0;j<planets.length;j++){
 if (planets[j].plot_planet_style.plot_what[1]){
   g.setColor( planets[j].plot_planet_style.sphere_color );
   float f = MainImage.scale_factor/MainImage.Default_scale_factor;
   float fi=(int)((float)(planets[j].plot_planet_style.sphere_radius+1)*f);i=(int)fi;
   float fi2=fi*0.5f+0.5f; int i2 = (int)fi2;
   g.fillOval(history[hist.increment_history -1 ][j].pixels[0]-i2, history[hist.increment_history][j].pixels[1] -i2 ,i,i);
 }
  if (planets[j].plot_planet_style.plot_what[0]){
   g.setColor(  planets[j].plot_planet_style.sphere_color );
   i=0;
   g.drawOval(history[hist.increment_history -1 ][j].pixels[0], history[hist.increment_history -1 ][j].pixels[1],0,0);
 }
 if (planets[j].plot_planet_style.plot_what[3]){ // current velocity normal
   g.setColor(  planets[j].plot_planet_style.sphere_color );
   x0=history[hist.increment_history -1 ][j].pixels[0];
   y0=history[hist.increment_history -1 ][j].pixels[1];
 //  update_the_pixels_1point(float[] r, float[] out)
 //  drawing.paintArrow(g,x0,y0,x1,y1);
 }
 }

}// increment history
}

 private void update_plot_1_step( int iii ) {
 int i;
 for(i=0;i<planet_operation.N_objects; i++)  {

 }

 };

 //end deal with plots

 //deal with history





private void update_the_pixels_1point(float[] r, float[] out){
float cosT=0, sinT=0, cosP=0, sinP=0, cosTcosP=0,cosTsinP=0, sinTcosP=0, sinTsinP=0;
 float x0=0,y0=0,z0=0,x1=0,y1=0;
         double theta = Math.PI*MainImage.orient.azimuth/180.0;
         double phi = Math.PI*MainImage.orient.elevation/180.0;
         cosT = (float)Math.cos(theta); sinT = (float)Math.sin(theta);
         cosP = (float)Math.cos(phi); sinP = (float)Math.sin(phi);
         cosTcosP = cosT*cosP; cosTsinP = cosT*sinP;
         sinTcosP = sinT*cosP; sinTsinP = sinT*sinP;
         // compute an orthographic projection
         x0 = r[0];y0 = r[1]; z0 = r[2];
         x1 = cosT*x0 + sinT*z0;
         y1 = -sinTsinP*x0 + cosP*y0 + cosTsinP*z0;
         //  adjust things to get a perspective projection
         float z1 = cosTcosP*z0 - sinTcosP*x0 - sinP*y0;
         //System.out.println(j+"x0="+x0+" "+y0+" "+z0);
         //System.out.println(j+"x1="+x1+" "+y1);
         x1 = x1*MainImage.perspective.near/(z1+MainImage.perspective.near+MainImage.perspective.near_to);
         y1 = y1*MainImage.perspective.near/(z1+MainImage.perspective.near+MainImage.perspective.near_to);

         // the 0.5 is to round off when converting to int
         out[0] = (int)(MainImage.width/2 + MainImage.scale_factor*x1 + 0.5);
         out[1] = (int)(MainImage.height/2 - MainImage.scale_factor*y1 + 0.5);
         //System.out.println( history[i][j].pixels[0]+ " "+ history[i][j].pixels[1]);
}








//public void update( Graphics g ) {
//      g.drawImage( MainImageBuffer, 0, 0, this );
//   }

  // public void paintr( Graphics g ) {
  //    update( g );}





         }



